﻿local L = LibStub("AceLocale-3.0"):GetLocale("Critters", false)

Critters = CreateFrame("frame")
local Critters = Critters
Critters:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
Critters:RegisterEvent("ADDON_LOADED")
function Critters:Print(...) ChatFrame1:AddMessage(string.join(" ", "|cFF33FF99Critters|r:", ...)) end

function Critters:ADDON_LOADED(event, addon)
	if addon:lower() ~= "Critters" then return end
	local _, class = UnitClass("player")
	for k, macro in pairs (self.macros[class]) do
		self.macros['GENERAL'][k] = macro
	end
	self.locked = {}
	for k in pairs (self.macros['GENERAL']) do
		self.locked[k] = true
	end
	defaults = {
		['class'] = {
			cm = 'Default',
		},
		['char'] = {
			cmloc = 'class',
			cmenabled = false,
			Critters = {},
		},
		['global'] = {
			['macros'] = self.macros['GENERAL'],
		}
	}
	self.db = LibStub("AceDB-3.0"):New("CrittersDB", defaults, 'class')

	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil
	if IsLoggedIn() then self:PLAYER_LOGIN() else self:RegisterEvent("PLAYER_LOGIN") end
	
	-- register SlashCommand
	SLASH_Critters1 = "/Critters";
	SlashCmdList["Critters"] = function()
		InterfaceOptionsFrame_OpenToCategory(self.optframe.Critters)
	end
end

function Critters:PLAYER_LOGIN()
	if GetMacroIndexByName("Critters") == 0 then
		CreateMacro("Critters", 1, '')
	end
	self:Scan()
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("COMPANION_LEARNED")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self.PLAYER_LOGIN = nil
	self:UpdateOptions()
end

function Critters:PLAYER_REGEN_DISABLED()
	--self:CombatMacro()
end

function Critters:PLAYER_REGEN_ENABLED()
	--self:SelectMacro()
end

function Critters:COMPANION_LEARNED()
	self:Scan()
end

function Critters:UNIT_SPELLCAST_SUCCEEDED(event, arg1, arg2)
	if arg1 == 'player' and self.db.char.Critters[arg2] then
		self:UpdateMacro()
	end
end

function Critters:UpdateMacro()
	local bugs = {}
	for k, priority in pairs(self.db.char.Critters) do
		if priority ~= 0 then
			for i=1, priority do
				bugs[#bugs+1] = k
			end
		end
	end
	EditMacro(GetMacroIndexByName("Critters"), "Critters", 1, string.format('#showtooltip\n/cast %s', bugs[math.random(1,#bugs)]))
end

function Critters:Scan()
	local creatureName, creatureSpellID, mounttype, mountspeed
	for id = 1,GetNumCompanions("CRITTER") do
		creatureSpellID= select(3, GetCompanionInfo("CRITTER", id))
		creatureName = GetSpellInfo(creatureSpellID);
		self.db.char.Critters[creatureName] = self.db.char.Critters[creatureName] or 5
	end
	self:UpdateMacro()
	self:UpdateOptions()
end
